# Bugsnag error reporter for JavaScript
[![Documentation](https://img.shields.io/badge/docs-latest-blue.svg)](https://docs.bugsnag.com/platforms/browsers)
[![Build status](https://travis-ci.org/bugsnag/bugsnag-js.svg?branch=master)](https://travis-ci.org/bugsnag/bugsnag-js)

The Bugsnag error reporter for JavaScript automatically detects and reports
errors and exceptions in your client-side JavaScript code.

The library is incredibly small, has no external dependencies (not even
jQuery!), and works in all browsers (even mobile browsers!), so you can safely
use it on any website.
[See the browser compatibility guide for more information](https://docs.bugsnag.com/platforms/browsers/compatibility/).

Learn more about Bugsnag's [JavaScript error
monitoring](https://bugsnag.com/platforms/javascript) solution.

## Getting started

1. [Create a Bugsnag account](https://bugsnag.com)
2. Complete the instructions in the [integration guide](https://docs.bugsnag.com/platforms/browsers)
3. Report handled exceptions using
   [`Bugsnag.notifyException()`](https://docs.bugsnag.com/platforms/browsers/#reporting-handled-exceptions)
4. Customize your integration using the
   [configuration options](https://docs.bugsnag.com/platforms/browsers/configuration-options/)

## Support

* Check out the [FAQ](https://docs.bugsnag.com/platforms/browsers/faq/) and [configuration options](https://docs.bugsnag.com/platforms/browsers/configuration-options/)
* [Search open and closed issues](https://github.com/bugsnag/bugsnag-js/issues?q=is%3Aissue) for similar problems
* [Report a bug or request a feature](https://github.com/bugsnag/bugsnag-js/issues/new)

## Contributing

All contributors are welcome! For information on how to build, test, and release
`bugsnag-js`, see our
[contributing guide](https://github.com/bugsnag/bugsnag-js/blob/master/CONTRIBUTING.md).

## License

The Bugsnag JS library is free software released under the MIT License. See
[LICENSE.txt](https://github.com/bugsnag/bugsnag-js/blob/master/LICENSE.txt) for
details.
